<html>
<head>
<title>OGRE: OgrePlatformInformation.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgrePlatformInformation.h</h1><a href="OgrePlatformInformation_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __PlatformInformation_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __PlatformInformation_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 <span class="comment">//</span>
<a name="l00036"></a>00036 <span class="comment">// TODO: Puts following macros into OgrePlatform.h?</span>
<a name="l00037"></a>00037 <span class="comment">//</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">/* Initial CPU stuff to set.</span>
<a name="l00040"></a>00040 <span class="comment">*/</span>
<a name="l00041"></a><a class="code" href="OgrePlatformInformation_8h.html#e606623294d49af88c609d5855ee418b">00041</a> <span class="preprocessor">#define OGRE_CPU_UNKNOWN    0</span>
<a name="l00042"></a><a class="code" href="OgrePlatformInformation_8h.html#03ad9692ca81e2302d7048c9d7695415">00042</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_CPU_X86        1</span>
<a name="l00043"></a><a class="code" href="OgrePlatformInformation_8h.html#98616201d2102b59d9d10666f3ce8762">00043</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_CPU_PPC        2</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="comment">/* Find CPU type</span>
<a name="l00046"></a>00046 <span class="comment">*/</span>
<a name="l00047"></a>00047 <span class="preprocessor">#if (defined(_MSC_VER) &amp;&amp; (defined(_M_IX86) || defined(_M_X64))) || \</span>
<a name="l00048"></a>00048 <span class="preprocessor">    (defined(__GNUC__) &amp;&amp; (defined(__i386__) </span><span class="comment">/*|| defined(__x86_64__)*/</span>))
<a name="l00049"></a>00049 <span class="preprocessor">#   define OGRE_CPU OGRE_CPU_X86</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE &amp;&amp; defined(__BIG_ENDIAN__)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_PPC</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_X86</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00056"></a>00056 <span class="preprocessor">#else</span>
<a name="l00057"></a><a class="code" href="OgrePlatformInformation_8h.html#719f8e35fd54bc7946246292a772e5cc">00057</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_UNKNOWN</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00060"></a>00060 <span class="comment">/* Find how to declare aligned variable.</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ALIGNED_DECL(type, var, alignment)  __declspec(align(alignment)) type var</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065 <span class="preprocessor">#elif OGRE_COMPILER == OGRE_COMPILER_GNUC</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ALIGNED_DECL(type, var, alignment)  type var __attribute__((__aligned__(alignment)))</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="preprocessor">#else</span>
<a name="l00069"></a><a class="code" href="OgrePlatformInformation_8h.html#f405686ffe3dd6aa1b9683a99e5990ed">00069</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ALIGNED_DECL(type, var, alignment)  type var</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00074"></a>00074 <span class="preprocessor">#if OGRE_CPU == OGRE_CPU_X86</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_SIMD_ALIGNMENT  16</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>
<a name="l00077"></a>00077 <span class="preprocessor">#else</span>
<a name="l00078"></a><a class="code" href="OgrePlatformInformation_8h.html#30f03b7a029b1b1303e8f816b68c3368">00078</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_SIMD_ALIGNMENT  16</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>
<a name="l00081"></a>00081 <span class="comment">/* Declare variable aligned to SIMD alignment.</span>
<a name="l00082"></a>00082 <span class="comment">*/</span>
<a name="l00083"></a><a class="code" href="OgrePlatformInformation_8h.html#e6883e4c8b217447e45bdaec1b1465af">00083</a> <span class="preprocessor">#define OGRE_SIMD_ALIGNED_DECL(type, var)   OGRE_ALIGNED_DECL(type, var, OGRE_SIMD_ALIGNMENT)</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>
<a name="l00085"></a>00085 <span class="comment">/* Define whether or not Ogre compiled with SSE supports.</span>
<a name="l00086"></a>00086 <span class="comment">*/</span>
<a name="l00087"></a>00087 <span class="preprocessor">#if OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_X86 &amp;&amp; OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_SSE  1</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_X86 &amp;&amp; OGRE_COMPILER == OGRE_COMPILER_GNUC</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_SSE  1</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="preprocessor">#ifndef __OGRE_HAVE_SSE</span>
<a name="l00095"></a><a class="code" href="OgrePlatformInformation_8h.html#c00688e814459c227d0c68a0f6352da7">00095</a> <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_SSE  0</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00114"></a><a class="code" href="classOgre_1_1PlatformInformation.html">00114</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PlatformInformation.html" title="Class which provides the run-time platform information Ogre runs on.">PlatformInformation</a>
<a name="l00115"></a>00115     {
<a name="l00116"></a>00116     <span class="keyword">public</span>:
<a name="l00117"></a>00117 
<a name="l00119"></a><a class="code" href="classOgre_1_1PlatformInformation.html#f7f9306631264031789d89af0642a807">00119</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1PlatformInformation.html#f7f9306631264031789d89af0642a807" title="Enum describing the different CPU features we want to check for, platform-dependent...">CpuFeatures</a>
<a name="l00120"></a>00120         {
<a name="l00121"></a>00121 <span class="preprocessor">#if OGRE_CPU == OGRE_CPU_X86</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span>            CPU_FEATURE_SSE         = 1 &lt;&lt; 0,
<a name="l00123"></a>00123             CPU_FEATURE_SSE2        = 1 &lt;&lt; 1,
<a name="l00124"></a>00124             CPU_FEATURE_SSE3        = 1 &lt;&lt; 2,
<a name="l00125"></a>00125             CPU_FEATURE_MMX         = 1 &lt;&lt; 3,
<a name="l00126"></a>00126             CPU_FEATURE_MMXEXT      = 1 &lt;&lt; 4,
<a name="l00127"></a>00127             CPU_FEATURE_3DNOW       = 1 &lt;&lt; 5,
<a name="l00128"></a>00128             CPU_FEATURE_3DNOWEXT    = 1 &lt;&lt; 6,
<a name="l00129"></a>00129             CPU_FEATURE_CMOV        = 1 &lt;&lt; 7,
<a name="l00130"></a>00130             CPU_FEATURE_TSC         = 1 &lt;&lt; 8,
<a name="l00131"></a>00131             CPU_FEATURE_FPU         = 1 &lt;&lt; 9,
<a name="l00132"></a>00132             CPU_FEATURE_PRO         = 1 &lt;&lt; 10,
<a name="l00133"></a>00133             CPU_FEATURE_HTT         = 1 &lt;&lt; 11,
<a name="l00134"></a>00134 <span class="preprocessor">#endif</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>
<a name="l00136"></a><a class="code" href="classOgre_1_1PlatformInformation.html#f7f9306631264031789d89af0642a8071bea16c1677fe68834a2d76b968562d7">00136</a>             CPU_FEATURE_NONE        = 0
<a name="l00137"></a>00137         };
<a name="l00138"></a>00138 
<a name="l00144"></a>00144         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getCpuIdentifier(<span class="keywordtype">void</span>);
<a name="l00145"></a>00145 
<a name="l00151"></a>00151         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a> getCpuFeatures(<span class="keywordtype">void</span>);
<a name="l00152"></a>00152 
<a name="l00158"></a>00158         <span class="keyword">static</span> <span class="keywordtype">bool</span> hasCpuFeature(CpuFeatures feature);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00162"></a>00162         <span class="keyword">static</span> <span class="keywordtype">void</span> log(<a class="code" href="classOgre_1_1Log.html" title="Log class for writing debug/log data to files.">Log</a>* pLog);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     };
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="preprocessor">#endif  // __PlatformInformation_H__</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
